package nu.zoom.dsl.ast;

import nu.zoom.dsl.parser.EndpointsLexer;
import nu.zoom.dsl.parser.EndpointsParser;
import org.antlr.v4.runtime.CharStreams;
import org.antlr.v4.runtime.CommonTokenStream;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Path;

public class ParserWrapper {
    public static DocumentNode parse(Path sourcePath) throws IOException {
        var ins = CharStreams.fromPath(sourcePath, StandardCharsets.UTF_8);
        EndpointsLexer lexer = new EndpointsLexer(ins);
        EndpointsParser parser = new EndpointsParser(new CommonTokenStream(lexer));
        var document = parser.document();
        var astTransformer = new EndpointsVisitorTransformer();
        astTransformer.visit(document);
        return new DocumentNode(astTransformer.getConfig(), astTransformer.getDataTypes(), astTransformer.getEndpoints());
    }
}
